/*
    Project: TCGINA
    Version: V1.26
    File   : miscw.c

    Copyright (c) 2005-2009 Author of TCGINA DLL. All rights reserved.
    Public Key Fingerprint: 294B A769 4A0A CC05 DAE6 00DD FF47 8C72 4097 67CE

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#include <windows.h>
#include "misc.h"

BOOL CopyStringW(LPWSTR pwszDest, size_t cchSize, LPCWSTR pwszSrc)
{
    size_t nSrcLen;

    if (pwszDest == NULL || pwszSrc == NULL) {
        return FALSE;
    }

    nSrcLen = wcslen(pwszSrc);
    if (nSrcLen >= cchSize) return FALSE;

    memcpy(pwszDest, pwszSrc, (nSrcLen+1)*sizeof(WCHAR));

    return TRUE;
}

BOOL AppendStringW(LPWSTR pwszDest, size_t cchSize, LPCWSTR pwszSrc)
{
    size_t nDestLen, nSrcLen;

    if (pwszDest == NULL || pwszSrc == NULL) {
        return FALSE;
    }

    nSrcLen = wcslen(pwszSrc);
    nDestLen = wcslen(pwszDest);
    if (nSrcLen + nDestLen >= cchSize) {
        return FALSE;
    }

    memcpy(pwszDest + nDestLen, pwszSrc, (nSrcLen+1)*sizeof(WCHAR));

    return TRUE;
}

